/*
 * info-607,
 * fonctions diverses pour le TP2
 */
#include "tp2.h"

/*
 * modulo mathématique sur les entiers 64 bits
 */
int64_t mod(int64_t x, int64_t m) {
    return ((x%m) + m) % m;
}

/*
 * affiche un entier t bits en binaire
 */
void print_bin(word m, int t) {
    for (int i=0;i<t;i++) {
        printf("%d ",BIT(t-1-i,m));
    }
}

/*
 * calcule le pgcd et les nombres de Bezout pour a et b
 * (les autres arguments sont utilisés pour renvoyer le résultat)
 */
void gcd_bezout (int64_t* g, int64_t* x, int64_t* y, int64_t a, int64_t b) {
    int64_t xx = 0; int64_t old_x = 1;
    int64_t yy = 1; int64_t old_y = 0;
    int64_t rr = b; int64_t  old_r = a;
    int64_t q, tmp;
    while (rr != 0) {
        q = old_r / rr;
        tmp = rr; rr = old_r - q * tmp; old_r = tmp;
        tmp = xx; xx = old_x - q * tmp; old_x = tmp;
        tmp = yy; yy = old_y - q * tmp; old_y = tmp;
    }
    if (old_r<0) {*g = -old_r;} else {*g = old_r;}
    *x = old_x; *y = old_y;
    if (-*g == a**x + b**y) {*x = -*x; *y = -*y;}
    assert (*g>0);
    assert (a * *x + b * *y == *g);
}

/*
 * calcul le pgcd de a et b
 */
int64_t gcd(int64_t a, int64_t b) {
    int64_t g,x,y;
    gcd_bezout(&g,&x,&y,a,b);
    return g;
}


